program Project2;
{$APPTYPE CONSOLE}
uses
  sysutils,
  Classes,
  TypInfo,
  Forms,
  PaxCompiler,
  PaxProgram,
  PaxRegister,
  IMPORT_Common;

type
  TMyHandler = class
  public
    procedure CreateObjectHandler(Sender: TPaxProgram;
                                  Instance: TObject);
  end;

procedure TMyHandler.CreateObjectHandler(Sender: TPaxProgram;
                                  Instance: TObject);
var
  pti: PTypeInfo;
  ptd: PTypeData;
  S: String;
begin
  writeln('OnCreateObject:');

  if Instance is TForm then
  begin
    pti := Instance.ClassInfo;
    ptd := GetTypeData(pti);
    if FileExists(ptd^.UnitName + '.dfm') then
      Sender.LoadDFMFile(Instance, ptd^.UnitName + '.dfm');
  end;
end;

var
  MyHandler: TMyHandler;
  PaxCompiler1: TPaxCompiler;
  PaxProgram1: TPaxProgram;
  PaxPascalLanguage1: TPaxPascalLanguage;
begin
  // Build all units, save pcu-files and create compiled script

  MyHandler := TMyHandler.Create;
  PaxCompiler1 := TPaxCompiler.Create(nil);

  PaxProgram1 := TPaxProgram.Create(nil);
  PaxProgram1.OnCreateObject := MyHandler.CreateObjectHandler;
  PaxPascalLanguage1 := TPaxPascalLanguage.Create(nil);

  try
    PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
    PaxCompiler1.AddModule('1', 'Pascal');
    PaxCompiler1.AddCode('1', 'uses Forms, unit2;');
    PaxCompiler1.AddCode('1', 'var F: TForm2;');
    PaxCompiler1.AddCode('1', 'begin');
    PaxCompiler1.AddCode('1', ' F := TForm2.Create(nil);');
    PaxCompiler1.AddCode('1', ' F.ShowModal;');
    PaxCompiler1.AddCode('1', ' F.Free;');
    PaxCompiler1.AddCode('1', 'end.');

    if PaxCompiler1.Compile(PaxProgram1) then
    // build with run-time packages
      PaxProgram1.Run
    else
    begin
      writeln(PaxCompiler1.ErrorMessage[0]);
      writeln(PaxCompiler1.ErrorLine[0]);
    end;
  finally
    PaxCompiler1.Free;
    PaxProgram1.Free;
    PaxPascalLanguage1.Free;
    MyHandler.Free;
  end;

  writeln('Press any key...');
  Readln;
end.

